﻿using System.Net.Mail;

namespace MammothMicro.SmtpGuardFilter.Filter
{
    /// <summary>
    /// Allow filtering of incoming email
    /// </summary>
    public interface IEmailFilter
    {
        /// <summary>
        /// Test the email to determine if it should be allowed
        /// </summary>
        /// <param name="message"></param>
        /// <returns></returns>
        bool Accept(MailMessage message);
  
        
        /// <summary>
        /// Loads or reloads filter data from the storage
        /// </summary>
        void Reload();
    }
}