﻿using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Mail;
using MammothMicro.SMTPGuard.Common;

namespace MammothMicro.SmtpGuardFilter.Filter
{
    public class TrustedIpFilter : IEmailFilter
    {
        private List<string> _list = new List<string>();
        public bool Accept(MailMessage message)
        {
            var ips = Tools.ExtractIp(message).ToList();
            if (ips.Count == 0)
                return false;

            return _list.Exists(p => p == ips[0].ToString());
        }

        public void Reload()
        {
            var path = System.IO.Path.GetDirectoryName(
                System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            path = path.Remove(0, 6);
            var reader = new StreamReader(path + @"\configuration\trustedIpList.txt");
            var text = reader.ReadToEnd().ToLower();
            reader.Close();
            const string delimiter = "\r\n";
            var t = text.Split(delimiter.ToCharArray());
            _list = t.ToList();
        }
    }
}


